/* Programa para controlar la secuencia de iluminación de leds con un pulsador
 * ¿Qué hemos visto de nuevo en este programa?
 * - Uso de constantes 
 * - Englobar código en funciones y llamar a estas funciones desde el 
 * bucle principal del programa cuando las queramos ejecutar
 * - El bucle while
 * - El uso de pulsadores
 * - El uso de digitalRead
 * 
 * La información de este programa la encuentras en:
 * https://robertogomez.info/aprende-a-usar-pulsadores-de-la-forma-correcta-en-arduino
 * 
 * Puedes muchos más recursos útiles de arduino en: 
 * https://robertogomez.info/blog
 */


const int inputPulsador = 7;
const int tiempoTemporizado = 200; // tiempo prefijado en el que alternamos la secuencia de iluminación de los leds 
                             //se expresa en milisegundos ( 1 segundo es igual a 1000 milisegundos)


void setup() {
//definimos los pines que vamos a utilizar, y el modo cómo vamos a usarlos, de entrada o de salida
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(13, OUTPUT);
  pinMode(inputPulsador, INPUT);
  //Para activar la resistencia interna PULL UP en el pin seleccionado de Arduino
  //pinMode(inputPulsador, INPUT_PULLUP); //Verificar la conexión del pulsador según hemos explicado en la entrada del blog
}

void loop() {

  int valorPulsador = 0;
  valorPulsador = digitalRead(inputPulsador);  

  while (valorPulsador == HIGH) {
    secuenciaLEDS();
    valorPulsador = digitalRead(inputPulsador);  
  }
 
}

void secuenciaLEDS () {
  
  int contador = 1; //variable para recorrer las salidas de los leds a iluminar
  int variableParpadeo = 0;

  for (int x = 1; x<5; x++){
    digitalWrite(contador, LOW);
    contador++;
    digitalWrite(contador, HIGH);
    delay(tiempoTemporizado);
  }

  for (int x = 1; x<4; x++){
    digitalWrite(contador, LOW);
    contador--;
    digitalWrite(contador, HIGH);
    delay(tiempoTemporizado);
  }

  for (int x = 1; x<7; x++){
    if (variableParpadeo == 0) {
      digitalWrite(2, HIGH);
      digitalWrite(3, HIGH);
      digitalWrite(4, HIGH);
      digitalWrite(5, HIGH);
      digitalWrite(13, HIGH);
      variableParpadeo++;
    } else {
      digitalWrite(2, LOW);
      digitalWrite(3, LOW);
      digitalWrite(4, LOW);
      digitalWrite(5, LOW);
      digitalWrite(13, LOW);
      variableParpadeo--;
    }
  delay(tiempoTemporizado);
  }
  
}
